
_Main_Init:

;electronique_interface_midi_008_16f628.mpas,38 :: 		begin
;electronique_interface_midi_008_16f628.mpas,39 :: 		CMCON := 7;            // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_interface_midi_008_16f628.mpas,40 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_interface_midi_008_16f628.mpas,41 :: 		INTCON.GIE := 1;       // |- enable interrupt
	BSF        INTCON+0, 7
;electronique_interface_midi_008_16f628.mpas,42 :: 		INTCON.PEIE := 1;      // |
	BSF        INTCON+0, 6
;electronique_interface_midi_008_16f628.mpas,43 :: 		TRISA      := %11111111;
	MOVLW      255
	MOVWF      TRISA+0
;electronique_interface_midi_008_16f628.mpas,44 :: 		TRISB      := %11100010;
	MOVLW      226
	MOVWF      TRISB+0
;electronique_interface_midi_008_16f628.mpas,45 :: 		PORTA      := 0;  // clear porta
	CLRF       PORTA+0
;electronique_interface_midi_008_16f628.mpas,46 :: 		PORTB      := 0;  // clear portb
	CLRF       PORTB+0
;electronique_interface_midi_008_16f628.mpas,47 :: 		T1CON.T1CKPS1 := 1;
	BSF        T1CON+0, 5
;electronique_interface_midi_008_16f628.mpas,50 :: 		TXSTA.SYNC := 0;    // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_interface_midi_008_16f628.mpas,51 :: 		TXSTA.TX9 := 0;     // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_interface_midi_008_16f628.mpas,52 :: 		TXSTA.TXEN := 1;    // Tx enabled
	BSF        TXSTA+0, 5
;electronique_interface_midi_008_16f628.mpas,53 :: 		RCSTA.CREN := 1;    // enable receiving / accept continuous mode
	BSF        RCSTA+0, 4
;electronique_interface_midi_008_16f628.mpas,54 :: 		RCSTA.SPEN := 1;    // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_interface_midi_008_16f628.mpas,55 :: 		RCSTA.RX9 := 0;     // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_interface_midi_008_16f628.mpas,56 :: 		PIE1.RCIE := 1;     // enable interrupt for UART Rx
	BSF        PIE1+0, 5
;electronique_interface_midi_008_16f628.mpas,58 :: 		UART1_Init(31250);  // speed for MIDI communication
	MOVLW      15
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_interface_midi_008_16f628.mpas,59 :: 		end;
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_interface_midi_008_16f628.mpas,62 :: 		begin
;electronique_interface_midi_008_16f628.mpas,63 :: 		if TestBit(PIR1, RCIF) then
	CLRF       R0+0
	BTFSS      PIR1+0, 5
	GOTO       L__Interrupt5
	MOVLW      1
	MOVWF      R0+0
L__Interrupt5:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt3
;electronique_interface_midi_008_16f628.mpas,66 :: 		RxData := RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _RxData+0
;electronique_interface_midi_008_16f628.mpas,69 :: 		if ((RxData = cMIDI_AS1) and In_Filter_AS1) then
	MOVF       _RxData+0, 0
	XORLW      254
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	CLRF       R0+0
	BTFSC      RA0_bit+0, 0
	INCF       R0+0, 1
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt7
;electronique_interface_midi_008_16f628.mpas,70 :: 		bDataReceived := false
	CLRF       _bDataReceived+0
	GOTO       L__Interrupt8
;electronique_interface_midi_008_16f628.mpas,71 :: 		else if ((RxData = cMIDI_AS2) and In_Filter_AS2) then
L__Interrupt7:
	MOVF       _RxData+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	CLRF       R0+0
	BTFSC      RA1_bit+0, 1
	INCF       R0+0, 1
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt10
;electronique_interface_midi_008_16f628.mpas,72 :: 		bDataReceived := false
	CLRF       _bDataReceived+0
	GOTO       L__Interrupt11
;electronique_interface_midi_008_16f628.mpas,73 :: 		else
L__Interrupt10:
;electronique_interface_midi_008_16f628.mpas,74 :: 		bDataReceived := true;
	MOVLW      255
	MOVWF      _bDataReceived+0
L__Interrupt11:
L__Interrupt8:
;electronique_interface_midi_008_16f628.mpas,75 :: 		if TestBit(RCSTA, OERR) then
	CLRF       R0+0
	BTFSS      RCSTA+0, 1
	GOTO       L__Interrupt15
	MOVLW      1
	MOVWF      R0+0
L__Interrupt15:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt13
;electronique_interface_midi_008_16f628.mpas,77 :: 		ClearBit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_interface_midi_008_16f628.mpas,78 :: 		SetBit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_interface_midi_008_16f628.mpas,79 :: 		end;
L__Interrupt13:
;electronique_interface_midi_008_16f628.mpas,81 :: 		end;
L__Interrupt3:
;electronique_interface_midi_008_16f628.mpas,82 :: 		end;
L__Interrupt29:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Note_Play:

;electronique_interface_midi_008_16f628.mpas,85 :: 		begin
;electronique_interface_midi_008_16f628.mpas,86 :: 		UART1_Write(Data1);
	MOVF       FARG_Note_Play_Data1+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_008_16f628.mpas,87 :: 		UART1_Write(Data2);
	MOVF       FARG_Note_Play_Data2+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_008_16f628.mpas,88 :: 		UART1_Write(Data3);
	MOVF       FARG_Note_Play_Data3+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_008_16f628.mpas,89 :: 		end;
	RETURN
; end of _Note_Play

_Welcome:

;electronique_interface_midi_008_16f628.mpas,92 :: 		begin
;electronique_interface_midi_008_16f628.mpas,93 :: 		Note_Play(cMIDI_Note_On, cMIDI_Pitch_base, cMIDI_Vel_On);
	MOVLW      144
	MOVWF      FARG_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_Note_Play_Data2+0
	MOVLW      100
	MOVWF      FARG_Note_Play_Data3+0
	CALL       _Note_Play+0
;electronique_interface_midi_008_16f628.mpas,94 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__Welcome18:
	DECFSZ     R13+0, 1
	GOTO       L__Welcome18
	DECFSZ     R12+0, 1
	GOTO       L__Welcome18
	DECFSZ     R11+0, 1
	GOTO       L__Welcome18
	NOP
;electronique_interface_midi_008_16f628.mpas,95 :: 		Note_Play(cMIDI_Note_Off, cMIDI_Pitch_base, cMIDI_Vel_Off);
	MOVLW      128
	MOVWF      FARG_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_Note_Play_Data2+0
	CLRF       FARG_Note_Play_Data3+0
	CALL       _Note_Play+0
;electronique_interface_midi_008_16f628.mpas,96 :: 		Delay_ms(30);
	MOVLW      78
	MOVWF      R12+0
	MOVLW      235
	MOVWF      R13+0
L__Welcome19:
	DECFSZ     R13+0, 1
	GOTO       L__Welcome19
	DECFSZ     R12+0, 1
	GOTO       L__Welcome19
;electronique_interface_midi_008_16f628.mpas,97 :: 		end;
	RETURN
; end of _Welcome

_main:

;electronique_interface_midi_008_16f628.mpas,99 :: 		begin
;electronique_interface_midi_008_16f628.mpas,100 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_interface_midi_008_16f628.mpas,103 :: 		Welcome;
	CALL       _Welcome+0
;electronique_interface_midi_008_16f628.mpas,105 :: 		while true do
L__main22:
;electronique_interface_midi_008_16f628.mpas,109 :: 		if bDataReceived then
	MOVF       _bDataReceived+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main27
;electronique_interface_midi_008_16f628.mpas,111 :: 		UART1_Write(RxData);
	MOVF       _RxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_008_16f628.mpas,112 :: 		bDataReceived := false;
	CLRF       _bDataReceived+0
;electronique_interface_midi_008_16f628.mpas,113 :: 		end;
L__main27:
;electronique_interface_midi_008_16f628.mpas,115 :: 		end;
	GOTO       L__main22
;electronique_interface_midi_008_16f628.mpas,116 :: 		end.
	GOTO       $+0
; end of _main
